
.NOLIST
.386
.model flat,stdcall
option casemap:none   
	include translate.inc
	_DEBUG equ
	include \vc\crtdbg.sdk	
	include \vc\stdio.sdk
	include \vc\stdlib.sdk
	include \vc\string.sdk
	include windows.sdk
	;include shlwapi.sdk
	include macros.inc
includelib  libcmtd.lib 
includelib  user32.lib
.const
SET_CRT_DEBUG_FIELD MACRO value:REQ
	invoke _CrtSetDbgFlag,_CRTDBG_REPORT_FLAG
	;Returns the previous state of _crtDbgFlag
	or eax,value
	invoke _CrtSetDbgFlag,eax
ENDM
AFFICHE MACRO chaine,numvalue
%ECHO chaine numvalue
ENDM 



_OutputHeading PROTO  :DWORD 
extern c _FPinit:dword	; to load floating point library
invalid_parameter PROTO C :DWORD,  :DWORD,  :DWORD,  :DWORD,  :DWORD 
.data
invalid db "invalid parameter",0
barre DB	0aH, 0aH, '%s:', 0aH, '**********************************'
	DB	'****************************************', 0aH, 00H
string_buf db 100 dup (0)
.LISTALL
fichier db "crt_dbg.asm",0
.NOLIST
.code

;################################################################
_OutputHeading PROC  pexplane:DWORD 
			Local  retour:DWORD
         mov retour,1
	invoke _CrtDbgReport,NULL,NULL,NULL,NULL,addr barre,pexplane	
 Finde_OutputHeading:
         mov eax,retour
         ret
_OutputHeading endp

;################################################################



;################################################################
invalid_parameter PROC C expression:DWORD,function,file,line,pReserved
			Local  retour:DWORD
	mov retour,1
	;all parameters expression:DWORD,function,file,line,pReserved are NULL	
	invoke MessageBox,NULL,ADDR invalid,NULL,MB_OK
Findeinvalid_parameter:
	mov eax,retour
	ret
invalid_parameter endp

;################################################################	
	
main PROC C argc:DWORD,pargv:DWORD
	Local p1:DWORD,p2,hLogFile
	Local s1:_CrtMemState,s2,s3
;_CrtMemState	STRUCT
;	pBlockHeader DWORD ?
;	lCounts DWORD _MAX_BLOCKS dup (?)
;	lSizes DWORD _MAX_BLOCKS dup (?)
;	lHighWaterCount DWORD ?
;	lTotalCount DWORD ?
;_CrtMemState		ENDS	
	;fichier de sortie
	mov hLogFile,0
	;<<<<<<<<<<<<<<<<<
  	;invoke CreateFile,SADR("report.txt"), GENERIC_WRITE,FILE_SHARE_WRITE, NULL,\
	; 			CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL
	;mov hLogFile,eax
	lea eax,fichier		
	;pour les fonctions scurises sprintf_s ......
	invoke _set_invalid_parameter_handler,invalid_parameter
	; Send all reports to STDOUT
	invoke _CrtSetReportMode,_CRT_WARN, _CRTDBG_MODE_FILE
	invoke _CrtSetReportFile, _CRT_WARN, _CRTDBG_FILE_STDOUT ;hLogFile  <<<<<<<<<<<<<
	invoke _CrtSetReportMode,_CRT_ERROR, _CRTDBG_MODE_FILE 
	invoke _CrtSetReportFile,_CRT_ERROR, _CRTDBG_FILE_STDOUT ;hLogFile <<<<<<<<<<<<<
	invoke _CrtSetReportMode,_CRT_ASSERT, _CRTDBG_MODE_FILE
	invoke _CrtSetReportFile,_CRT_ASSERT,_CRTDBG_FILE_STDOUT ; hLogFile <<<<<<<<<<<<<
	; Allocate 2 memory blocks and store a string in each
	invoke malloc,34
	mov p1,eax
	invoke strcpy_s,p1,34,SADR("This is the p1 string |34 bytes|.")
	invoke malloc,34
	mov p2,eax
	invoke strcpy_s,p2,34,SADR("This is the p2 string |34 bytes|.")	
	invoke _OutputHeading,SADR("Don't Use _ASSERTE  to check that the two strings are identical")
	invoke _OutputHeading,SADR("Use _CRTMemDumpAllObjectsSince to check the p1 and p2 allocations")
	invoke _CrtMemDumpAllObjectsSince,NULL	
	;------------------------
	invoke free,p2
	;-------------------------------
	invoke _OutputHeading,SADR("Having freed p2, dump allocation information about p1 only")
	invoke _CrtMemDumpAllObjectsSince,NULL	
   	;Store a memory checkpoint in the s1 memory-state structure
   	invoke _CrtMemCheckpoint,addr s1
	; Allocate another block, pointed to by p2
	invoke malloc,38
	mov p2,eax
	invoke strcpy_s,p2,38,SADR("This new p2 string occupies 38 bytes.")

	;Store a 2nd memory checkpoint in s2
	invoke _CrtMemCheckpoint,addr s2

	invoke _OutputHeading,SADR("Dump the changes that occurred between two memory checkpoints")
	invoke _CrtMemDifference,addr s3,addr s1,addr s2
	.if eax != 0
		invoke _CrtMemDumpStatistics,addr s3
	.endif
  	;Free p2 again and store a new memory checkpoint in s2
   	invoke free,p2
   	invoke _CrtMemCheckpoint,addr s2

   	invoke _OutputHeading,SADR("Now the memory state at the two checkpoints is the same")
	invoke _CrtMemDifference,addr s3,addr s1,addr s2
	.if eax != 0
		invoke _CrtMemDumpStatistics,addr s3
	.endif
	;get a bad size to p1 to outpass the secured function,p1 is 34
   	invoke strcpy_s,p1,38,SADR("This new p1 string is over 34 bytes")
   	invoke _OutputHeading,SADR("Free p1 after overwriting the end of the allocation")
   	invoke free,p1
   	;Set the debug-heap flag so that freed blocks are kept on the
   	;linked list, to catch any inadvertent use of freed memory
   	SET_CRT_DEBUG_FIELD _CRTDBG_DELAY_FREE_MEM_DF
   	invoke malloc,10
	mov p1,eax
	invoke free,p1
   	invoke strcpy_s,p1,10,SADR("Oops")
  	invoke _OutputHeading,SADR("Perform a memory check after corrupting freed memory")
   	invoke _CrtCheckMemory
   	;Use explicit calls to _malloc_dbg to save file name and line number
   	;information, and also to allocate Client type blocks for tracking
	.LISTALL
   	invoke _malloc_dbg,40,_NORMAL_BLOCK,addr fichier, @Line
	.NOLIST
	mov p1,eax
   	invoke _malloc_dbg,40,_CLIENT_BLOCK,addr fichier,@Line
	mov p2,eax
   	invoke strcpy_s,p1,40,SADR("p1 points to a Normal allocation block")
   	invoke strcpy_s,p2,40,SADR("p2 points to a Client allocation block")

  	;You must use _free_dbg to free a Client block
   	invoke _OutputHeading,SADR("Using free to free a Client block causes an assertion failure")
   	invoke free,p1
   	invoke free,p2

   	invoke malloc,10
	mov p1,eax
   	invoke _OutputHeading,SADR("Examine outstanding allocations {dump memory leaks}")
   	invoke _CrtDumpMemoryLeaks

   	;Set the debug-heap flag so that memory leaks are reported when
   	;the process terminates. Then, exit.
   	invoke _OutputHeading,SADR("Program exits without freeing a memory block")
   	SET_CRT_DEBUG_FIELD _CRTDBG_LEAK_CHECK_DF	
	;invoke CloseHandle,hLogFile	<<<<<<<<<<<<<<<<<
	ret
main endp

end  
										
